      Program IRC_list
      Implicit Double Precision(a-h, o-z)
C
      Parameter(Mx_Point=100, Mx_Atom=20)
      Character*90 CC, Datfile1, Datfile2
C
C ----- Data dimension -----
C
      Dimension npoint(Mx_Point),stotal(Mx_Point),totale(Mx_Point),
     1          C(3, Mx_Atom, Mx_Point),
     2          r1(Mx_Point), r2(Mx_Point), r3(Mx_Point), 
     3          a1(Mx_Point)
      Data NFT, no / 10, 11 / 
      Data hartree, jm,cm, angs, amu, h / 27.211397d0,96.4853d3 
     1                ,8065.541d0,1.0d-10, 1.672649d-27, 6.6260755d-34/
C
      Call Getarg(1, Datfile1)
      Call Getarg(2, Datfile2)
C
      IW = 6
      Mx_Data = Mx_Point/2
C
C ----- Read IRC File -----
C
      Open(NFT, file=Datfile1, status='OLD', ERR=99)

         Do I = 1, Mx_Data
            Read(NFT, 9000, END=110) CC
            Read(NFT, 9000) CC
            Read(CC(7:10), *)  npoint(I)
            Read(CC(20:28), *) stotal(I)
            Read(CC(35:52), *) totale(I)
            Read(NFT, 9000) CC
            Do J = 1, Mx_Atom
               Read(NFT, 9000) CC
               If (CC(1:4) .eq. 'MASS') goto 60 
               Read(CC(17:80), *) (C(K, J, I), K = 1, 3)
            End do
  60        NAtom = J - 1
            Do J = 1, NAtom
               Read(NFT, 9000) CC
            End do
         End do
 110     N_Dat1 = I - 1

      Close(NFT)
C
C ----- READ IRB File -----
C
      Open(NFT, file=Datfile2, status='OLD', ERR=99)

         Do I = 1, Mx_Data
            Read(NFT, 9000, END=210) CC
            Read(NFT, 9000) CC
            Read(CC(7:10), *)  npoint(I + N_Dat1)
            Read(CC(20:28), *) stotal(I + N_Dat1)
            Read(CC(35:52), *) totale(I + N_Dat1)
            Read(NFT, 9000) CC
            stotal(N_Dat1+I) = -stotal(N_Dat1+I)
            Do J = 1, Mx_Atom
               Read(NFT, 9000) CC
               If (CC(1:4) .eq. 'MASS') goto 160
               Read(CC(17:80), *) (C(K, J, I+N_Dat1), K = 1, 3)
            End do
 160        NAtom = J -1
            Do J = 1, NAtom
               Read(NFT, 9000) CC
            End do
          End do
 210      N_Dat2 = I - 1

      Close(NFT)
C
C ----- IRC data -----
C
      Do I = 1, N_Dat1
         Write(IW, 9100) npoint(I), stotal(I), totale(I)
         Do J = 1, NAtom
            write(IW, 9200) (C(K, J, I), K = 1, 3)
         End do
      End do
C
C ----- IRB data -----
C
      Do I = N_Dat1+1, N_Dat1+N_Dat2
         Write(IW, 9100) npoint(I), stotal(I), totale(I)
         Do J = 1, NAtom
            write(IW, 9200) (C(K, J, I), K = 1, 3)
         End do
      End do
C
C ----- Internal coordinate -----
C
C r1 = r(CH),  r2 = r(CO),  r3= = r(OH)               
C
      Write(IW, "('*********************************************')")
      Write(IW, "('    s           E       r(CH)  r(CO)  r(OH)')")
      Do I = N_Dat1+N_Dat2, N_Dat1+1, -1
         r1(I)=sqrt((C(1,1,I)-C(1,2,I))**2+(C(2,1,I)-C(2,2,I))**2+
     1         (C(3,1,I)-C(3,2,I))**2)*0.529177 
         r2(I)=sqrt((C(1,2,i)-C(1,3,i))**2+(C(2,2,I)-C(2,3,I))**2+
     1         (C(3,2,I)-C(3,3,I))**2)*0.529177
         r3(I)=sqrt((C(1,1,i)-C(1,3,i))**2+(C(2,1,I)-C(2,3,I))**2+
     1         (C(3,2,I)-C(3,3,I))**2)*0.529177
         write(IW, 9300) stotal(I),totale(I),r1(I),r2(I),r3(I)
      End do
      Do I = 1, N_Dat1
         r1(I)=sqrt((C(1,1,I)-C(1,2,I))**2+(C(2,1,I)-C(2,2,I))**2+
     1         (C(3,1,I)-C(3,2,I))**2)*0.529177 
         r2(I)=sqrt((C(1,2,i)-C(1,3,i))**2+(C(2,2,I)-C(2,3,I))**2+
     1         (C(3,2,I)-C(3,3,I))**2)*0.529177
         r3(I)=sqrt((C(1,1,i)-C(1,3,i))**2+(C(2,1,I)-C(2,3,I))**2+
     1         (C(3,2,I)-C(3,3,I))**2)*0.529177
         write(IW, 9300) stotal(I),totale(I),r1(I),r2(I),r3(I)
      End do
      Write(IW, "('*********************************************')")
C
      Stop
  99  Write(6,*) 'ERROR in opening dat file'
      Stop
 9000 Format(a90)
 9100 Format(I3,3X,F8.5,3X,F11.5)
 9200 Format(30X,3(F9.6,4x))
 9300 Format(F9.5,2X,F11.6,3(2X,F5.3))
      End
