      Program IRC_READ
C
      Implicit Double Precision (a-h, o-z)
C
      Parameter (MaxAtom=500)
      Parameter (MaxPoint=500)
C
      Dimension X(5)
      Dimension C(3, MaxAtom, MaxPoint)
      Dimension E(MaxPoint), R(MaxPoint)
      Dimension Label_bond(2, MaxAtom*3), bond(MaxAtom*3)
      Dimension Label_angle(3, MaxAtom*3), angle(MaxAtom*3)
      Dimension Label_dihedral(4, MaxAtom*3), dihedral(MaxAtom*3)
      Character*255 CC, FILENAME1, FILENAME2
C
      IW  =   6
      IR  =  10
C
      NAtom = 0
C
      N_Point1 = 1
      N_Point2 = 1
C
      Call Getarg(1, FILENAME1)
      Call Getarg(2, FILENAME2)
C
C ----- Read IRC Output File -----
C
      Open(IR, FILE=FILENAME1, STATUS='UNKNOWN',
     1     ACCESS='SEQUENTIAL', FORM='FORMATTED')

  100    Read(IR, 9000, END=900) CC
            If (CC(26:46) .eq. "Z-Matrix orientation:") goto 150
            If (CC(26:46) .eq. "Standard orientation:") goto 150
            If (CC(1:24) .eq. "    -- Optimized point #") then
  110          Read(IR, 9000, END=900) CC
                  If (CC(4:26) .eq. "NET REACTION COORDINATE") then
                     Read(CC(46:56), *) R(N_Point1)
                     Goto 120
                  End if
               Goto 110
  120          Write(IW, 9100) N_Point1, R(N_Point1), E(N_Point1)
               Do J = 1, NAtom
                  Write(IW, 9200) (C(K, J, N_Point1), K = 1, 3)
               End do
               N_Point1 = N_Point1 + 1
               Goto 100
            End if
         Goto 100

  150    Do I = 1, 4
            Read(IR, 9000) CC
         End do
         Do I = 1, MaxAtom
            Read(IR, 9000, END=900) CC
            If (CC(2:11) .eq. "----------") then
               NAtom = I - 1
               Goto 200
            End if
            Read(CC(35:70), *, ERR=900) (C(K, I, N_Point1), K = 1, 3)
         End do
         Goto 900

  200    Read(IR, 9000, END=900) CC
            Do J = 1, 30
               If (CC(J:J+2) .eq. ") =") then
                  Read(CC(J+3:J+18), *) E(N_Point1)
               Goto 100
               End if
            End do
         Goto 200

  900    N_Point1 = N_Point1 -1
         Write(IW, "(2X,I4,' points for ',a30/)") N_Point1, FILENAME1

      Close(IR)
C
C ----- Read IRB Output File -----
C
      Open(IR, FILE=FILENAME2, STATUS='UNKNOWN',
     1     ACCESS='SEQUENTIAL', FORM='FORMATTED')

 1100    Read(IR, 9000, END=1900) CC
            If (CC(26:46) .eq. "Z-Matrix orientation:") goto 1150
            If (CC(26:46) .eq. "Standard orientation:") goto 1150
            If (CC(1:24) .eq. "    -- Optimized point #") then
 1110          Read(IR, 9000, END=1900) CC
                  If (CC(4:26) .eq. "NET REACTION COORDINATE") then
                     Read(CC(46:56), *) R(N)
                     Goto 1120
                  End if
               Goto 1110
 1120          Write(IW, 9100) N_Point2, -R(N), E(N)
               R(N) = -R(N)
               Do J = 1, NAtom
                  Write(IW, 9200) (C(K, J, N), K = 1, 3)
               End do
               N_Point2 = N_Point2 + 1
               Goto 1100
            End if
         Goto 1100

 1150    Do I = 1, 4
            Read(IR, 9000) CC
         End do
         Do I = 1, MaxAtom
            Read(IR, 9000, END=1900) CC
            If (CC(2:11) .eq. "----------") then
               NAtom = I - 1
               Goto 1200
            End if
            N = N_Point1 + N_Point2
            Read(CC(35:70), *, ERR=1900) (C(K, I, N), K = 1, 3)
         End do
         Goto 1900

 1200    Read(IR, 9000, END=1900) CC
            Do J = 1, 30
               If (CC(J:J+2) .eq. ") =") then
                  Read(CC(J+3:J+18), *) E(N)
               Goto 1100
               End if
            End do
         Goto 1200

 1900    N_Point2 = N_Point2 -1
         Write(IW, "(2X,I4,' points for ',a30/)") N_Point2, FILENAME2

      Close(IR)
C
C ----- IRB data -----
C
C     Do I = N_Point1+N_Point2, N_Point1+1, -1
C        Write(IW, 9100) I, R(I), E(I)
C        Do J = 1, NAtom
C           Write(IW, 9200) (C(K, J, I), K = 1, 3)
C        End do
C     End do
C
C ----- IRC data -----
C
C     Do I = 1, N_Point1
C        Write(IW, 9100) I, R(I), E(I)
C        Do J = 1, NAtom
C           Write(IW, 9200) (C(K, J, I), K = 1, 3)
C        End do
C     End do
C
C ----- Internal coordinate -----
C
C r1 = r(CH),  r2 = r(CO),  r3= = r(OH)
C
      Write(IW, "('*********************************************')")
      Write(IW, "('    s           E       r(CH)  r(CO)  r(OH)')")
      Do I = N_Point1+N_Point2, N_Point1+1, -1
         r1=sqrt((C(1,1,I)-C(1,2,I))**2+(C(2,1,I)-C(2,2,I))**2+
     1      (C(3,1,I)-C(3,2,I))**2)
         r2=sqrt((C(1,2,I)-C(1,3,I))**2+(C(2,2,I)-C(2,3,I))**2+
     1      (C(3,2,I)-C(3,3,I))**2)
         r3=sqrt((C(1,1,I)-C(1,3,I))**2+(C(2,1,I)-C(2,3,I))**2+
     1      (C(3,2,I)-C(3,3,I))**2)
         write(IW, 9300) R(I), E(I), r1, r2, r3
      End do
      Do I = 1, N_Point1
         r1=sqrt((C(1,1,I)-C(1,2,I))**2+(C(2,1,I)-C(2,2,I))**2+
     1      (C(3,1,I)-C(3,2,I))**2)
         r2=sqrt((C(1,2,I)-C(1,3,i))**2+(C(2,2,I)-C(2,3,I))**2+
     1      (C(3,2,I)-C(3,3,I))**2)
         r3=sqrt((C(1,1,I)-C(1,3,i))**2+(C(2,1,I)-C(2,3,I))**2+
     1      (C(3,2,I)-C(3,3,I))**2)
         write(IW, 9300) R(I), E(I), r1, r2, r3
      End do
      Write(IW, "('*********************************************')")
C
C
      Stop
 8000 Write(IW, "('Error: EOF')")
      Stop
 9000 Format(a255)
 9100 Format(I3,3X,F8.5,3X,F11.5)
 9200 Format(30X,3(F9.6,4x))
 9300 Format(F9.5,2X,F11.6,3(2X,F5.3))
      End
